
#include "hello.h"

int main ( void )
{
	Hello *obj;
	M_Hello *classObj;
	
    Environment ev;
	SOM_InitEnvironment ( & ev );

	/* allocate a Hello object */
    obj = HelloNew ();
	if ( obj ) {
		
		_sayHello ( obj, & ev );
		
		__set_msg ( obj, & ev, " <from C client: Like a turkey!> " );
		
		_sayHello ( obj, & ev );
		
		_somFree ( obj );
	}
    
	/* obtain a reference to the class object */
	classObj = somNewClassReference ( Hello );
	if ( classObj ) {
		
		/* allocate a Hello object via its metaclass interface */
		obj = _HelloCreate ( classObj, & ev, " <from C client: Like a frog!> " );
		
		/* the reference to the class object may now be safely
			released.  it could just as easily be released at
			the end of this block. */

		somReleaseClassReference ( classObj );
		
		if ( obj ) {

			_sayHello ( obj, & ev );
				
			_somFree ( obj );
		}
	}
	
	SOM_UninitEnvironment ( & ev );
    return 0;
}

