
#define Hello_Class_Source
#include "hello.ih"


#include <string.h>


SOM_Scope void  SOMLINK sayHello (Hello *somSelf, Environment *ev)
{
    somPrintf ( " <from C method: Quack!... >\n" );
    somPrintf ( "%s\n", _get_msg ( somSelf, ev ) );
	somPrintf ( "-------\n" );
}

SOM_Scope void  SOMLINK somInit (Hello *somSelf)
{
    Environment ev;
	SOM_InitEnvironment ( & ev );

	/* parent call through of somInit is a nop */
    __set_msg ( somSelf, & ev, " <from C override: Like a duck!> " );

	SOM_UninitEnvironment ( & ev );
}


SOM_Scope Hello*  SOMLINK HelloCreate (M_Hello *somSelf, Environment *ev,
		string message)
{
    Hello *obj;
	static char temp [256];

	strcpy ( temp, " [ from C MetaClassInit:" );
    strcat ( temp, message );
	strcat ( temp, " ] " );
	
	obj = _somNew ( somSelf );
	if ( obj ) 
	    __set_msg ( obj, ev, temp );
    
    return obj;
}

